/* *********************************************************************** 
** From SQL Server Magazine - September 2003
** Recovering from Isolated Corruption
** Use this script to SETUP for the PARTIAL and STANDBY options
** used to investigate damaged databases.

** NOTE: This script is best viewed in Courier New 12pt
*********************************************************************** */

-- This is an excellent script to see how to get closer and closer to when data
-- became damaged. You MUST modify the dates/times of these STOPAT 
-- parameter based on the completion of the SetupTestCaseforPartial&Stopat.sql
-- script. Review the associated article for more details.

RESTORE HEADERONLY 
FROM DISK = N'C:\Program Files\Microsoft SQL Server\MSSQL\BACKUP\PubsTestBackup.dat' 

RESTORE DATABASE NewPubsTest
	FILEGROUP = 'RWFG'
FROM DISK = N'C:\Program Files\Microsoft SQL Server\MSSQL\BACKUP\PubsTestBackup.dat' 
WITH PARTIAL,
	MOVE 'pubs' TO 'C:\Program Files\Microsoft SQL Server\MSSQL\DATA\NewPubs.mdf',
	MOVE 'pubs_log' TO 'C:\Program Files\Microsoft SQL Server\MSSQL\DATA\NewPubs_Log.ldf',
	MOVE 'PubsTestRWFile1' TO 'C:\Program Files\Microsoft SQL Server\MSSQL\DATA\NewPubsTestRWFile1.ndf',
	MOVE 'PubsTestRWFile2' TO 'C:\Program Files\Microsoft SQL Server\MSSQL\DATA\NewPubsTestRWFile2.ndf',
	MOVE 'PubsTestRWFile3' TO 'C:\Program Files\Microsoft SQL Server\MSSQL\DATA\NewPubsTestRWFile3.ndf',
	MOVE 'PubsTestROFile1' TO 'C:\Program Files\Microsoft SQL Server\MSSQL\DATA\NewPubsTestROFile1.ndf',
	MOVE 'PubsTestROFile2' TO 'C:\Program Files\Microsoft SQL Server\MSSQL\DATA\NewPubsTestROFile2.ndf',
FILE = 1, -- this is the backup number by position
STANDBY = N'C:\Program Files\Microsoft SQL Server\MSSQL\BACKUP\PubsTestUNDO.dat' 
go
-- Review the output of sp_helpfile to see that all of the files related to the primary
-- filegroup, the RWFG filegroup (because that was the one that was specified)
-- and the transaction log - are restored. The files which are a member of other
-- filegroups (like the ROFG) are listed but review their size(s). Also, check to
-- see if the file(s) were created (they shouldn't be there!)...
USE NewPubsTest
go
sp_helpfile
go

SELECT count(*) FROM NewPubsTest.dbo.DemoTable -- 2000 rows
go

-- Use RESTORE HEADERONLY to look at the BackupFinishDate of the last 
-- log and use a time 3 minutes prior (we know our loop took about 3.5 minutes)
RESTORE HEADERONLY 
FROM DISK = N'C:\Program Files\Microsoft SQL Server\MSSQL\BACKUP\PubsTestBackup.dat' 
go

USE master
go

RESTORE LOG NewPubsTest
FROM DISK = N'C:\Program Files\Microsoft SQL Server\MSSQL\BACKUP\PubsTestBackup.dat' 
WITH FILE = 2, -- this is the backup number by position
	STOPAT = '2003-06-20 13:38:00',
STANDBY = N'C:\Program Files\Microsoft SQL Server\MSSQL\BACKUP\PubsTestUNDO.dat' 
go

SELECT count(*) FROM NewPubsTest.dbo.DemoTable -- 2050 rows
go

RESTORE LOG NewPubsTest
FROM DISK = N'C:\Program Files\Microsoft SQL Server\MSSQL\BACKUP\PubsTestBackup.dat' 
WITH FILE = 2, -- this is the backup number by position
	STOPAT = '2003-06-20 13:39:00',
STANDBY = N'C:\Program Files\Microsoft SQL Server\MSSQL\BACKUP\PubsTestUNDO.dat' 
go

SELECT count(*) FROM NewPubsTest.dbo.DemoTable -- 2110 rows
go

RESTORE LOG NewPubsTest
FROM DISK = N'C:\Program Files\Microsoft SQL Server\MSSQL\BACKUP\PubsTestBackup.dat' 
WITH FILE = 2, -- this is the backup number by position
	STOPAT = '2003-06-20 13:40:00',
STANDBY = N'C:\Program Files\Microsoft SQL Server\MSSQL\BACKUP\PubsTestUNDO.dat' 
go

SELECT count(*) FROM NewPubsTest.dbo.DemoTable -- 2169 rows
go

-- Last one to completion
RESTORE LOG NewPubsTest
FROM DISK = N'C:\Program Files\Microsoft SQL Server\MSSQL\BACKUP\PubsTestBackup.dat' 
WITH FILE = 2, -- this is the backup number by position
--	STOPAT = '2003-06-20 13:40:00',
STANDBY = N'C:\Program Files\Microsoft SQL Server\MSSQL\BACKUP\PubsTestUNDO.dat' 
go

SELECT count(*) FROM NewPubsTest.dbo.DemoTable -- 2200 rows
go

-- Now the next log

RESTORE LOG NewPubsTest
FROM DISK = N'C:\Program Files\Microsoft SQL Server\MSSQL\BACKUP\PubsTestBackup.dat' 
WITH FILE = 4, -- this is the backup number by position
	STOPAT = '2003-06-20 13:41:00',
STANDBY = N'C:\Program Files\Microsoft SQL Server\MSSQL\BACKUP\PubsTestUNDO.dat' 
go

SELECT count(*) FROM NewPubsTest.dbo.DemoTable -- 2229 rows
go

RESTORE LOG NewPubsTest
FROM DISK = N'C:\Program Files\Microsoft SQL Server\MSSQL\BACKUP\PubsTestBackup.dat' 
WITH FILE = 4, -- this is the backup number by position
	STOPAT = '2003-06-20 13:42:00',
STANDBY = N'C:\Program Files\Microsoft SQL Server\MSSQL\BACKUP\PubsTestUNDO.dat' 
go

SELECT count(*) FROM NewPubsTest.dbo.DemoTable -- 2289 rows
go

RESTORE LOG NewPubsTest
FROM DISK = N'C:\Program Files\Microsoft SQL Server\MSSQL\BACKUP\PubsTestBackup.dat' 
WITH FILE = 4, -- this is the backup number by position
	STOPAT = '2003-06-20 13:43:00',
STANDBY = N'C:\Program Files\Microsoft SQL Server\MSSQL\BACKUP\PubsTestUNDO.dat' 
go

SELECT count(*) FROM NewPubsTest.dbo.DemoTable -- 2248 rows
go

RESTORE LOG NewPubsTest
FROM DISK = N'C:\Program Files\Microsoft SQL Server\MSSQL\BACKUP\PubsTestBackup.dat' 
WITH FILE = 4, -- this is the backup number by position
	STOPAT = '2003-06-20 13:44:00',
STANDBY = N'C:\Program Files\Microsoft SQL Server\MSSQL\BACKUP\PubsTestUNDO.dat' 
go

SELECT count(*) FROM NewPubsTest.dbo.DemoTable -- 2407 rows
go

RESTORE LOG NewPubsTest
FROM DISK = N'C:\Program Files\Microsoft SQL Server\MSSQL\BACKUP\PubsTestBackup.dat' 
WITH FILE = 4, -- this is the backup number by position
	STOPAT = '2003-06-20 13:45:00',
STANDBY = N'C:\Program Files\Microsoft SQL Server\MSSQL\BACKUP\PubsTestUNDO.dat' 
go

SELECT count(*) FROM NewPubsTest.dbo.DemoTable -- 2647 rows
go

RESTORE LOG NewPubsTest
FROM DISK = N'C:\Program Files\Microsoft SQL Server\MSSQL\BACKUP\PubsTestBackup.dat' 
WITH FILE = 4, -- this is the backup number by position
	STOPAT = '2003-06-20 13:46:00',
STANDBY = N'C:\Program Files\Microsoft SQL Server\MSSQL\BACKUP\PubsTestUNDO.dat' 
go

SELECT count(*) FROM NewPubsTest.dbo.DemoTable -- 2527 rows
go

RESTORE LOG NewPubsTest
FROM DISK = N'C:\Program Files\Microsoft SQL Server\MSSQL\BACKUP\PubsTestBackup.dat' 
WITH FILE = 4, -- this is the backup number by position
	STOPAT = '2003-06-20 13:47:00',
STANDBY = N'C:\Program Files\Microsoft SQL Server\MSSQL\BACKUP\PubsTestUNDO.dat' 
go

SELECT count(*) FROM NewPubsTest.dbo.DemoTable -- 2587 rows
go

-- Last one to completion
RESTORE LOG NewPubsTest
FROM DISK = N'C:\Program Files\Microsoft SQL Server\MSSQL\BACKUP\PubsTestBackup.dat' 
WITH FILE = 4, -- this is the backup number by position
--	STOPAT = '2003-06-20 13:47:00',
STANDBY = N'C:\Program Files\Microsoft SQL Server\MSSQL\BACKUP\PubsTestUNDO.dat' 
go

SELECT count(*) FROM NewPubsTest.dbo.DemoTable -- 2600 rows
go
